//
//  common.h
//  Yon
//
//  Created by Miso on 6.8.2009.
//  Copyright 2009 Miso Antonic. All rights reserved.
//
//

#ifndef COMMON_H
#define COMMON_H

#include <assert.h>
#include <stdio.h>
#include <stdint.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>
#include <string>

using std::wstring;

// static long maxAlloc = 0;

#define MIN(a, b) ((a) < (b) ? (a) : (b))
#define MAX(a, b) ((a) > (b) ? (a) : (b))

// if (sizeof(type) > maxAlloc) {maxAlloc = sizeof(type); printf("max alloc: %d\n", maxAlloc);} 
#define NEW(var, type) {var = (type*)malloc(sizeof(type)); assert(var != NULL); }
// if (sizeof(type)*(count) > maxAlloc) {maxAlloc = sizeof(type)*(count); printf("max alloc2: %d %d %s %d\n", maxAlloc, sizeof(type), __FILE__, __LINE__);}
#define NEW_ARRAY(var, type, count) {var = (type*)malloc(sizeof(type)*(count)); assert(!count || var != NULL); }
#define REALLOC_ARRAY(var, type, count) {var = (type*)realloc(var, sizeof(type)*(count)); assert(!count || var != NULL);}

typedef uint64_t ULONG;
typedef int64_t LONG;
typedef unsigned char BYTE;
typedef double DOUBLE;

typedef wchar_t CHAR;
typedef CHAR* CHARREF;

typedef uint32_t CHAR32;

struct SourcePosition {
	ULONG minLine;
	ULONG minIndex;
	ULONG maxLine;
	ULONG maxIndex;
	ULONG sourceIdIndex;
	wstring toShortString() {
		CHAR buffer[255];
		swprintf(buffer, 255, L"(%4d, %2d) - (%4d, %2d)", (long)minLine+1, (long)minIndex+1, (long)maxLine+1, (long)maxIndex+1);
		return wstring(buffer);
	}
	wstring toMinString() {
		CHAR buffer[255];
		swprintf(buffer, 255, L"(%d : %d)", (long)minLine+1, (long)minIndex+1);
		return wstring(buffer);
	}
};

inline void printString(wstring s)
{
	fputws(s.c_str(), stdout);
}

#define SYMBOL_PLUS     1
#define SYMBOL_MINUS    2
#define SYMBOL_call                 3

#endif /* COMMON_H */